unit AddressBook;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Controls, Forms, Dialogs, ComCtrls,
  StdCtrls, Registry, Buttons, AddItem,
  ImgList, ExtCtrls;

type
  TAddressBook2 = class(TForm)
    ListView1: TListView;
    IconAddressBook: TImageList;
    StatusBar1: TStatusBar;
    IconApply: TBitBtn;
    IconCancel: TBitBtn;
    IconDelete: TBitBtn;
    IconAdd: TBitBtn;
    IconEdit: TBitBtn;
    Panel1: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure ApplyClick(Sender: TObject);
    procedure DeleteClick(Sender: TObject);
    procedure AddClick(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure EditClick(Sender: TObject);
  private
    { Private declarations }
    IniFile : TRegIniFile;
  public
    { Public declarations }
  end;

var
    AddressBook2 : TAddressBook2;
StackAddressBook : TStringList;

implementation

{$R *.DFM}

function GetExeName : string;
var
 Buffer: array[0..260] of Char;
begin
 SetString(Result, Buffer, GetModuleFileName(0, Buffer, SizeOf(Buffer)));
end;

procedure TAddressBook2.FormCreate(Sender: TObject);
var
   i1, i2, i3 : integer;
route, s1, s2 : string;

begin

//load icon for Address Book
IconAdd.Glyph.Handle:=LoadBitmap(HInstance,'005ADD');
IconEdit.Glyph.Handle:=LoadBitmap(HInstance,'004EDIT');
IconDelete.Glyph.Handle:=LoadBitmap(HInstance,'003TRASH');
IconApply.Glyph.Handle:=LoadBitmap(HInstance,'002OK');
IconCancel.Glyph.Handle:=LoadBitmap(HInstance,'001CANCEL');

//Load Register Listview1.Columns.Width
try
IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');
s1:=IniFile.ReadString('AddressBook','Name', s1);
Listview1.Columns[0].Width:=StrToInt(s1);
s1:=IniFile.ReadString('AddressBook','Organization', s1);
Listview1.Columns[1].Width:=StrToInt(s1);
s1:=IniFile.ReadString('AddressBook','EmailAddress', s1);
Listview1.Columns[2].Width:=StrToInt(s1);
s1:=IniFile.ReadString('AddressBook','Phone', s1);
Listview1.Columns[3].Width:=StrToInt(s1);
s1:=IniFile.ReadString('AddressBook','City', s1);
Listview1.Columns[4].Width:=StrToInt(s1);
finally
Listview1.Columns[0].Width:=65;
Listview1.Columns[1].Width:=169;
Listview1.Columns[2].Width:=212;
Listview1.Columns[3].Width:=104;
Listview1.Columns[4].Width:=97;
end;

try
route := IniFile.ReadString('Path','Location File', route);
route:=route+'\Address\AddressBook.txt';
finally
route := ExtractFilePath(application.exename)+ '\Address\AddressBook.txt';
end;

StackAddressBook:=TStringList.Create;
StackAddressBook.LoadFromFile(route);

try
s1:=StackAddressBook.Strings[0];
if (s1<>'')  then
begin
s2:=Copy(s1,17,Length(s1)-16);
i1:=StrToInt(s2);

Listview1.SortType:=(stNone);
i3:=1;
   for i2:=0 to i1-1 do
     begin
      ListView1.Items.Add.Caption:=StackAddressBook.Strings[i3];
      ListView1.Items[Listview1.Items.Count-1].SubItems.Append(StackAddressBook.Strings[i3+1]);
      ListView1.Items[Listview1.Items.Count-1].SubItems.Append(StackAddressBook.Strings[i3+2]);
      ListView1.Items[Listview1.Items.Count-1].SubItems.Append(StackAddressBook.Strings[i3+3]);
      ListView1.Items[Listview1.Items.Count-1].SubItems.Append(StackAddressBook.Strings[i3+4]);
      i3:=i3+6;
     end;
end;
     finally
     end;

   StatusBar1.Panels[1].Text:='Counted record: '+IntToStr(Listview1.Items.Count);
   IniFile.Destroy;
end;

procedure TAddressBook2.ApplyClick(Sender: TObject);
var
     a, b : integer;
route, b3 : string;

begin
StackAddressBook.Clear;
  StackAddressBook.Add('Counted record: ' + IntToStr(Listview1.Items.Count));
    for a:=0 to Listview1.Items.Count-1 do
       begin
           StackAddressBook.Add(Listview1.Items[a].Caption);
             for b:=0 to 3 do
               StackAddressBook.Add(Listview1.Items[a].SubItems[b]);
               StackAddressBook.Add('%');
       end;

       try
       IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');
       route := IniFile.ReadString('Path','Location File', route);
       route:=route+'\Address\AddressBook.txt';
       finally
       route := ExtractFilePath(application.exename)+ '\Address\AddressBook.txt';
       IniFile := TRegIniFile.Create(route);
       end;

       StackAddressBook.SaveToFile(route);
       StackAddressBook.Clear;

//Save Register Listview1.Columns.Width
   b3:=IntToStr(Listview1.Columns[0].Width);
   IniFile.WriteString('AddressBook','Name', b3);
    b3:=IntToStr(Listview1.Columns[1].Width);
   IniFile.WriteString('AddressBook','Organization', b3);
    b3:=IntToStr(Listview1.Columns[2].Width);
   IniFile.WriteString('AddressBook','EmailAddress', b3);
    b3:=IntToStr(Listview1.Columns[3].Width);
   IniFile.WriteString('AddressBook','Phone', b3);
    b3:=IntToStr(Listview1.Columns[4].Width);
   IniFile.WriteString('AddressBook','City', b3);
IniFile.Destroy;
close;
end;

procedure TAddressBook2.DeleteClick(Sender: TObject);
begin
   if  Listview1.Selcount=1 then
       begin
       Listview1.Selected.Delete;
       StatusBar1.Panels[1].Text:='Counted record: '+IntToStr(Listview1.Items.Count);
       StatusBar1.Panels[0].Text:='';
       end
    else begin
        MessageBeep(MB_ICONASTERISK);
        MessageDlg('You have not selected item.',mtError, [mbOk], 0);
    end;
end;

procedure TAddressBook2.AddClick(Sender: TObject);
var
s1,s2 : string;

begin
Listview1.SortType:=(stNone);
if Listview1.Items.Count<>500 then
Begin
with TAddItem2.Create(Application) do
  try
    ShowModal;
   finally
    Free;
    end;
  IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');
  s1:=IniFile.ReadString ('Temp','ButtonOK', s1);
  if s1='1' then
  begin
     StackAddressBook.Clear;
     s1:=IniFile.ReadString ('Temp','Name', s1);
     s2:=IniFile.ReadString ('Temp','Organization', s2);
     StackAddressBook.Add(s2);
     s2:=IniFile.ReadString ('Temp','EmailAddress', s2);
     StackAddressBook.Add(s2);
     s2:=IniFile.ReadString ('Temp','Phone', s2);
     StackAddressBook.Add(s2);
     s2:=IniFile.ReadString ('Temp','City', s2);
     StackAddressBook.Add(s2);
     ListView1.Items.Add.Caption:=s1;
     ListView1.Items[Listview1.Items.Count-1].SubItems.Assign(StackAddressBook);
     StatusBar1.Panels[1].Text:='Counted record: '+IntToStr(Listview1.Items.Count);
     Listview1.SortType:=(stText);
     StackAddressBook.Clear;
 end;
end
else begin MessageBeep(MB_ICONEXCLAMATION);
           MessageDlg('Address Book is full.',mtWarning,[mbOk], 0);
           end;
end;

procedure TAddressBook2.ListView1DblClick(Sender: TObject);
begin
  if  Listview1.Selcount=1 then
   begin
     StatusBar1.Panels[0].Text:='Send To: Ok';
      IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');
      IniFile.WriteString ('Temp','TestSelectedEmailAddress','1');
      IniFile.Destroy;
      close;
   end
    else
    begin
        MessageBeep(MB_ICONASTERISK);
          MessageDlg('You have not selected item.',mtError, [mbOk], 0);
    end;
end;

procedure TAddressBook2.ListView1Click(Sender: TObject);
begin
   if  Listview1.Selcount=1 then
   begin
    StatusBar1.Panels[0].Text:='Email address: "'+
    Listview1.Selected.Caption+'" <'+
    Listview1.Selected.SubItems[1]+'>';
    IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');
    IniFile.WriteString ('Temp','SelectedEmailAddress',Listview1.Selected.SubItems[1]);
    IniFile.Destroy;
   end;
end;

procedure TAddressBook2.EditClick(Sender: TObject);
begin
if  Listview1.Selcount=1 then
      begin
          IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');
          IniFile.WriteString('Temp','InsertItem', '1');

          IniFile.WriteString ('Temp','Name',Listview1.Selected.Caption);
          IniFile.WriteString ('Temp','Organization', Listview1.Selected.SubItems[0]);
          IniFile.WriteString ('Temp','EmailAddress', Listview1.Selected.SubItems[1]);
          IniFile.WriteString ('Temp','Phone', Listview1.Selected.SubItems[2]);
          IniFile.WriteString ('Temp','City', Listview1.Selected.SubItems[3]);

         with TAddItem2.Create(Application) do
             try
              ShowModal;
              finally
              Free;
             end;

        Listview1.Selected.Caption:=IniFile.ReadString ('Temp','Name', Listview1.Selected.Caption);
        Listview1.Selected.SubItems[0]:=IniFile.ReadString ('Temp','Organization', Listview1.Selected.SubItems[0]);
        Listview1.Selected.SubItems[1]:=IniFile.ReadString ('Temp','EmailAddress', Listview1.Selected.SubItems[1]);
        Listview1.Selected.SubItems[2]:=IniFile.ReadString ('Temp','Phone', Listview1.Selected.SubItems[2]);
        Listview1.Selected.SubItems[3]:=IniFile.ReadString ('Temp','City', Listview1.Selected.SubItems[3]);
        IniFile.Destroy;
  end
  else begin
        MessageBeep(MB_ICONASTERISK);
        MessageDlg('You have not selected item.',mtError, [mbOk], 0);
    end;
end;
end.
