unit MailBox;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ComCtrls, ExtCtrls, Gauges,
  SakEmail, Registry, Messages,
  New_Txt_Message, Menus, Preferences,
  Dialogs, AboutBox, ImgList;

const
wm_HideMenu = WM_USER + 2000;
wm_EnableMenu = WM_USER + 2001;

type
  TMail = class(TForm)
    StatusBar1: TStatusBar;
    SakPOP1: TSakPOP;
    SakMsgList1: TSakMsgList;
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    Options: TMenuItem;
    Info1: TMenuItem;
    GroupBox2: TGroupBox;
    ListView2: TListView;
    IconPOP: TImageList;
    comboBoxAttach: TComboBox;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Gauge3: TGauge;
    Gauge4: TGauge;
    ButtonSave: TBitBtn;
    CreateMsg1: TMenuItem;
    GetMsg1: TMenuItem;
    Stop1: TMenuItem;
    DeleteMsg1: TMenuItem;
    MemoMsgBox: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure showCurrentMsg;
    procedure ButtonSave2Click(Sender: TObject);
    procedure SakPOP1AfterRetrieve(Sender: TObject);
    procedure SakPOP1BeforeRetrieve(sender: TObject; id: Word);
    procedure SakPOP1DecodeProgress(Sender: TObject; Percent: Word);
    procedure SakPOP1DecodeStart(Sender: TObject; FileName: String;
      BytesCount: Integer);
    procedure SakPOP1Error(Sender: TObject; Error: Integer; Msg: String);
    procedure SakPOP1RetrieveProgress(Sender: TObject; Percent: Word);
    procedure SakPOP1DecodeEnd(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure NewMsg(Sender: TObject);
    procedure GetMsg1Click(Sender: TObject);
    procedure ListView2Click(Sender: TObject);
    procedure DeleteMsg1Click(Sender: TObject);
    procedure Stop1Click(Sender: TObject);
  private
    { Private declarations }
    IniFile : TRegIniFile;
  public
    { Public declarations }
  procedure WMUser (var msg: TMessage); message wm_User;
  procedure WMHideMenu (var msg: TMessage); message wm_HideMenu;
  procedure WMEnableMenu (var msg: TMessage); message wm_EnableMenu;
  end;

const
Months: array [1..12] of ShortString = ('Jan',
'Feb','Mar','Apr','May','Jun','Jul','Aug',
'Sep','Oct','Nov','Dec');

var
  Mail : TMail;

implementation

var password,login:string;

{$R *.DFM}

var    currentMsg: integer;

 {$H+}

procedure TMail.WMHideMenu (var msg: TMessage);
begin
GetMsg1.Enabled:=False;
CreateMsg1.Enabled:=False;
Options.Enabled:=False;
DeleteMsg1.Enabled:=False;
Info1.Enabled:=False;
end;

procedure TMail.WMEnableMenu (var msg: TMessage);
begin
GetMsg1.Enabled:=True;
CreateMsg1.Enabled:=True;
Options.Enabled:=True;
DeleteMsg1.Enabled:=True;
Info1.Enabled:=True;
end;

 procedure TMail.WMUser (var msg: TMessage);
begin
  Application.Restore;
end;

procedure TMail.FormCreate(Sender: TObject);
var
         Present : TDateTime;
Year, Month, Day : Word;

begin
  Stop1.Enabled:=False;
  Present:= Now;
  DecodeDate(Present, Year, Month, Day);
  StatusBar1.Panels[1].Text := 'Today is ' + IntToStr(Day) + '. '
   + Months[Month] + ' ' + IntToStr(Year);
end;

procedure TMail.showCurrentMsg;
var msg: TSakMsg;
      a: integer;
begin
    for a:=0 to SakMsgList1.count-1 do
       begin
      msg := SakMsgList1.items[currentMsg];
      ListView2.Items.Add.Caption:=msg.Subject;
      ListView2.Items[Listview2.Items.Count-1].SubItems.Append(msg.From);
      ListView2.Items[Listview2.Items.Count-1].SubItems.Append(msg.Date);
      inc(currentMsg);
      end;
end;

procedure TMail.ButtonSave2Click(Sender: TObject);
begin
     saveDialog1.FileName := comboBoxAttach.text;
     if saveDialog1.execute then
        SakMsgList1[currentMsg].AttachedFiles[comboBoxAttach.itemIndex].saveToFile( saveDialog1.FileName);
end;

procedure TMail.SakPOP1AfterRetrieve(Sender: TObject);
begin
     StatusBar1.Panels[0].text := 'Retrieving... ' + intToStr( SakMsgList1.count) +
                                  ' msg(s) retrieved';
end;

procedure TMail.SakPOP1BeforeRetrieve(sender: TObject; id: Word);
begin
     Gauge3.Progress := 0;
end;

procedure TMail.SakPOP1DecodeProgress(Sender: TObject; Percent: Word);
begin
     Gauge4.Progress := Percent;
end;

procedure TMail.SakPOP1DecodeStart(Sender: TObject; FileName: String;
  BytesCount: Integer);
begin
   Gauge4.Progress := 0;
end;

procedure TMail.SakPOP1Error(Sender: TObject; Error: Integer;
  Msg: String);
begin
     ShowMessage( Msg);
end;

procedure TMail.SakPOP1RetrieveProgress(Sender: TObject;
  Percent: Word);
begin
     Gauge3.Progress := Percent;
end;

procedure TMail.SakPOP1DecodeEnd(Sender: TObject);
begin
 Gauge4.Progress := 0;
end;

procedure TMail.About1Click(Sender: TObject);
begin
Start_Window_AboutBox;
end;

procedure TMail.Options1Click(Sender: TObject);
begin
with TPreferences2.Create(Application) do
  try
    ShowModal;
  finally
    Free;
    end;
end;

procedure TMail.NewMsg(Sender: TObject);
begin
with TCreateTxt1.Create(Application) do
  try
    ShowModal;
  finally
    Free;
    end;
end;

procedure TMail.GetMsg1Click(Sender: TObject);
var
              passwd0,login0 : string;
testsavepassword, testcancel : string;
                       Hwnd : THandle;
                       i:integer;

begin
   Hwnd := FindWindow ('TMail', 'Simple mail');
   PostMessage (Hwnd, wm_HideMenu,0,0);

   IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');

   passwd0:=IniFile.ReadString ('Mailbox','Password', passwd0);
   login0:=IniFile.ReadString ('Mailbox','Login', login0);

     if (passwd0='') or (login0='') then
         begin

             with TPreferences2.Create(Application) do
               try
                    for i:=0 to 2 do PageControl1.SelectNextPage(true);
                    IniFile.WriteString ('Temp','Getmsg', '1');
                    ShowModal;

               finally
                    IniFile.WriteString ('Temp','Getmsg', '0');
                    login:=IniFile.ReadString ('Mailbox','Login', login);
                    password:=IniFile.ReadString ('Mailbox','Password', password);
                    testsavepassword:=IniFile.ReadString ('Mailbox','SavePassword', testsavepassword);

                    if testsavepassword='0' then IniFile.WriteString ('Mailbox','Password', '');

                    Free;

                    SakPOP1.Host := IniFile.ReadString ('Pop3','HostPop3', SakPOP1.Host);
                    SakPOP1.UserId := login;
                    SakPOP1.Passwd := password;
             end;
         end
    else
         begin
            SakPOP1.Host := IniFile.ReadString ('Pop3','HostPop3', SakPOP1.Host);
            SakPOP1.UserId := IniFile.ReadString ('Mailbox','Login', SakPOP1.UserId);
            SakPOP1.Passwd := IniFile.ReadString ('Mailbox','Password', SakPOP1.Passwd);
         end;

      testcancel:=IniFile.ReadString ('Temp','TestCancel', testcancel);

      if testcancel='1' then
         begin
             SendMessage (Hwnd, wm_EnableMenu,0,0);
             exit
         end
      else
         begin
        StatusBar1.Panels[0].Text := 'Wait a moment, please - contact your post server';

          SakPOP1.connect;

     if SakPOP1.POPError then
         begin
         StatusBar1.Panels[0].Text := 'Connecting: Fail';
         MessageBox(Mail.Handle, 'Connect failed. Maybe the server is down or not responding.','Error',MB_OK or MB_ICONERROR);
         StatusBar1.Panels[0].text := '';
         PostMessage (Hwnd, wm_EnableMenu,0,0);
         exit;
     end;

     if not SakPOP1.login then
         begin
           StatusBar1.Panels[0].Text := 'Connecting: Fail';
           MessageBox(Mail.Handle, 'Unauthorized access...','Error',MB_OK or MB_ICONERROR);
           PostMessage (Hwnd, wm_EnableMenu,0,0);
           exit;
         end;

  Stop1.Enabled:=True;
  StatusBar1.Panels[0].Text := 'Connecting: Ok  '+'->  You have ' +
  intToStr( SakPOP1.Init) + ' new msg(s) of ' +
  intToStr( SakPOP1.MsgsCount);


  sakPOP1.retrieveAllMessages( SakMsgList1);

   Gauge3.Progress := 0;
   SakPOP1.quit;
   Stop1.Enabled:=False;

PostMessage (Hwnd, wm_EnableMenu,0,0);

   if SakMsgList1.count > 0 then
     begin
          GetMsg1.Visible:=False;
          currentMsg := 0;
          showCurrentMsg;
     end;
     StatusBar1.Panels[0].text := 'Done. ' + intToStr( SakMsgList1.count) + ' msgs retrieved.';
     end;
end;

procedure TMail.ListView2Click(Sender: TObject);
var
    i : integer;
  msg : TSakMsg;
route : string;

begin
IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');
route := IniFile.ReadString('Path','Location File', route);
IniFile.Destroy;
   if  Listview2.Selcount=1 then
       begin
          comboBoxAttach.Text:='';
          currentMsg:=Listview2.Selected.Index;
          msg := SakMsgList1.items[currentMsg];
          MemoMsgBox.Clear;
          MemoMsgBox.Lines.Add(msg.Text.Text);
          MemoMsgBox.Lines.SaveToFile(route+'\Temp\working.tmp');
          MemoMsgBox.Clear;
          MemoMsgBox.Lines.LoadFromFile(route+'\Temp\working.tmp');

       if msg.AttachedFiles.Count <> 0 then
          begin
            comboBoxAttach.Items.Clear;

          for i := 0 to msg.AttachedFiles.Count-1 do
              comboBoxAttach.items.add( msg.AttachedFiles[ i].fileName);

              comboBoxAttach.enabled := true;
              comboBoxAttach.itemIndex := 0;
              buttonSave.enabled := true;
          end
      else
          begin
              comboBoxAttach.enabled := false;
              buttonSave.enabled := false;
          end;
      end;
end;

procedure TMail.DeleteMsg1Click(Sender: TObject);
var
   i : integer;

begin
   if MessageDlg('Do you wish to delete all messages',
      mtConfirmation, mbOkCancel, 0) <> idOk then Exit
   else
      begin
        if  Listview2.Items.Count <> 0 then
             begin
              Listview2.Items.Clear;

                 for i:=0 to Listview2.Items.Count do
                    SakMsgList1.Delete(i);

               MemoMsgBox.Lines.Clear;
               comboBoxAttach.Items.Clear;
               comboBoxAttach.Text:='';
               StatusBar1.Panels[0].text := '';
               GetMsg1.Visible:=True;
             end
        else
             begin
             MessageBeep(MB_ICONASTERISK);
             MessageDlg('Nothing to erase.',mtError, [mbOk], 0);
             end;
      end;
end;

procedure TMail.Stop1Click(Sender: TObject);
begin
StatusBar1.Panels[0].Text := 'Connecting: Stopped';
SakPOP1.Canceled := true;
MessageBox(Mail.Handle, 'Communication with server POP3 been stopped.','Error',MB_OK or MB_ICONERROR);
Stop1.Enabled:=False;
end;
end.

