unit New_Txt_Message;

interface

uses
  Windows, Controls, Forms, Dialogs,
  Registry,ComCtrls, ExtCtrls, StdCtrls,
  SysUtils,Menus,Classes,
  Addressbook,Preferences,SendMessage;

type
  TCreateTxt1 = class(TForm)
    MemoTextMsg: TMemo;
    OpenDialog1: TOpenDialog;
    OpenDialog2: TOpenDialog;
    OpenDialog3: TOpenDialog;
    MainMenu1: TMainMenu;
    Options1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Add1: TMenuItem;
    Delete1: TMenuItem;
    Clear1: TMenuItem;
    N1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    ListBoxAttachedFiles: TListBox;
    Label1: TLabel;
    EditTo: TEdit;
    EditSubject: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    EditCc: TEdit;
    Label4: TLabel;
    EditReplyTo: TEdit;
    SendMsg2: TMenuItem;
    Address1: TMenuItem;
    PopupMenu2: TPopupMenu;
    OpenFile2: TMenuItem;
    SaveFile1: TMenuItem;
    Clear2: TMenuItem;
    SaveDialog1: TSaveDialog;
    procedure Add1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure SendMsg1Click(Sender: TObject);
    procedure Options2Click(Sender: TObject);
    procedure Address1Click(Sender: TObject);
    procedure Clear2Click(Sender: TObject);
    procedure LoadFileClick(Sender: TObject);
    procedure SaveFileClick(Sender: TObject);
  private
    { Private declarations }
     IniFile : TRegIniFile;
     public
    { Public declarations }
  end;

var
  CreateTxt1: TCreateTxt1;

{$R *.DFM}
implementation

procedure TCreateTxt1.Add1Click(Sender: TObject);
begin
if openDialog1.execute then
 begin
   ListBoxAttachedFiles.items.add(OpenDialog1.FileName);
   Delete1.Enabled:=True;
    Clear1.Enabled:=True;
 end;
end;

procedure TCreateTxt1.Clear1Click(Sender: TObject);
begin
  ListBoxAttachedFiles.clear;
  Delete1.Enabled:=False;
  Clear1.Enabled:=False;
end;

procedure TCreateTxt1.Delete1Click(Sender: TObject);
begin
  ListBoxAttachedFiles.Items.Delete(ListBoxAttachedFiles.ItemIndex);

 if ListBoxAttachedFiles.Items.Count=0 then
     begin
       Delete1.Enabled:=False;
       Clear1.Enabled:=False;
     end;
 end;

procedure TCreateTxt1.SendMsg1Click(Sender: TObject);
var
           i : integer;
test1, route : string;

begin
IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');

if (EditTo.Text='') or (EditSubject.Text='') then
   begin
     MessageBeep(MB_ICONEXCLAMATION);
     MessageDlg('Field To: or Subject: is empty.',mtError,[mbOk], 0);
   end
else
   begin
     IniFile.WriteString ('Message','To',EditTo.Text);
     IniFile.WriteString ('Message','Subject',EditSubject.Text);
     IniFile.WriteString ('Message','Cc',EditCc.Text);
     IniFile.WriteString ('Message','ReplyTo',EditReplyTo.Text);
     IniFile.WriteString ('AttachedFiles','count',IntToStr(ListBoxAttachedFiles.Items.count));

     try
     route := IniFile.ReadString('Path','Location File', route);
     route:=route + '\Temp\working.tmp';
     finally
     route := ExtractFilePath(application.exename)+'\Temp\working.tmp';
     end;

     MemoTextMsg.Lines.SaveToFile(route);


     if ListBoxAttachedFiles.Items.count<>0 then
        begin
            for i:= 0 to ListBoxAttachedFiles.Items.count-1 do
              begin
                IniFile.WriteString ('AttachedFiles',IntToStr(i+1),ListBoxAttachedFiles.Items[i]);
              end;
        end;


      with TSend1.Create(Application) do
          try
             ShowModal;
          finally
             Free;
      end;

      test1:=IniFile.ReadString ('Temp','TestClose',test1);

      if test1='1' then
        begin
          IniFile.WriteString ('Temp','TestClose','0');
          close;
        end;
   end;
end;

procedure TCreateTxt1.Options2Click(Sender: TObject);
begin
   with TPreferences2.Create(Application) do
     try
        ShowModal;
     finally
        Free;
   end;
end;

procedure TCreateTxt1.Address1Click(Sender: TObject);
var
testaddto : string;

begin
    with TAddressBook2.Create(Application) do
       try
         ShowModal;
       finally
         Free;
    end;

    IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');
    testaddto:=IniFile.ReadString ('Temp','TestSelectedEmailAddress',testaddto);

    if testaddto='1' then
       begin
         EditTo.Text:=IniFile.ReadString ('Temp','SelectedEmailAddress',EditTo.Text);
         IniFile.WriteString ('Temp','TestSelectedEmailAddress','0');
       end;

    IniFile.Destroy;
end;

procedure TCreateTxt1.Clear2Click(Sender: TObject);
begin
  MemoTextMsg.Lines.Clear;
end;

procedure TCreateTxt1.LoadFileClick(Sender: TObject);
begin
if openDialog1.execute then
 begin
   MemoTextMsg.Lines.LoadFromFile(OpenDialog1.FileName);
 end;
end;

procedure TCreateTxt1.SaveFileClick(Sender: TObject);
begin
if SaveDialog1.execute then
   begin
     MemoTextMsg.Lines.SaveToFile(SaveDialog1.FileName);
   end;
end;

end.
