unit Preferences;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Controls, Forms, StdCtrls, Registry,
  Buttons, ComCtrls, ExtCtrls;

type
  TPreferences2 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet3: TTabSheet;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label1: TLabel;
    EditHostSmtp: TEdit;
    EditPortSmtp: TEdit;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    EditHostPop: TEdit;
    EditPortPop: TEdit;
    TabSheet2: TTabSheet;
    TabSheet4: TTabSheet;
    IconApply: TBitBtn;
    IconCancel: TBitBtn;
    GroupBox4: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    EditFrom: TEdit;
    EditUserName: TEdit;
    GroupBox3: TGroupBox;
    GroupBox8: TGroupBox;
    Label15: TLabel;
    Label20: TLabel;
    EditUserId: TEdit;
    EditPassword: TEdit;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    CheckBox3: TCheckBox;
    GroupBox7: TGroupBox;
    CheckBox5: TCheckBox;
    Panel1: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure SavePreferences;
    procedure LoadPreferences;
    procedure ApplyClick(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure CancelClick(Sender: TObject);
  private
    { Private declarations }
    IniFile : TRegIniFile;
  public
    { Public declarations }
  end;

var
  Preferences2: TPreferences2;

implementation

{$R *.DFM}

procedure TPreferences2.FormCreate(Sender: TObject);
begin
IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');
IconApply.Glyph.Handle:=LoadBitmap(HInstance,'002OK');
IconCancel.Glyph.Handle:=LoadBitmap(HInstance,'001CANCEL');
LoadPreferences;
end;

procedure TPreferences2.LoadPreferences;
var
deletemsg, password, s1 : string;
               position : integer;
begin
//Load User, Smtp, Pop
EditHostSmtp.Text := IniFile.ReadString ('Smtp','HostSmtp', EditHostSmtp.Text);
EditPortSmtp.Text := IniFile.ReadString ('Smtp','PortSmtp', EditPortSmtp.Text);
EditHostPop.Text := IniFile.ReadString ('Pop3','HostPop3', EditPortPop.Text);
EditPortPop.Text := IniFile.ReadString ('Pop3','PortPop3', EditPortPop.Text);
EditUserName.Text := IniFile.ReadString ('User','UserName', EditUserName.Text);
EditFrom.Text := IniFile.ReadString ('User','UserAddress', EditFrom.Text);

//load save password
EditUserId.Text:=IniFile.ReadString ('Mailbox','Login', EditUserId.Text);
password:=IniFile.ReadString ('Mailbox','SavePassword', password);

if password='1' then
      begin
      CheckBox3.Checked:=True;
      EditPassword.Text:=IniFile.ReadString ('Mailbox','Password', EditPassword.Text);
      end
      else
      CheckBox3.Checked:=False;

//load delete messages
deletemsg:=IniFile.ReadString ('Mailbox','Delete Messages', deletemsg);
if deletemsg='1' then
      CheckBox5.Checked:=True
      else
      CheckBox5.Checked:=False;

//Load priority message
s1 := IniFile.ReadString ('Message','PriorityMessage', s1);

RadioButton1.Checked:=False;
RadioButton2.Checked:=False;
RadioButton3.Checked:=False;
RadioButton4.Checked:=False;
RadioButton5.Checked:=False;

position:=Strtoint(s1);

case position of
    0 : RadioButton1.Checked:=True;//Priority := prHighest;
    1 : RadioButton2.Checked:=True;//Priority := prHigh;
    2 : RadioButton3.Checked:=True;//Priority := prNormal;
    3 : RadioButton4.Checked:=True;//Priority := prLow;
    4 : RadioButton5.Checked:=True;//Priority := prLowest;
end;
end;

procedure TPreferences2.SavePreferences;
var
getmsg : string;

begin
//Save User, Smtp, Pop, Mailbox
IniFile.WriteString ('Smtp','HostSmtp', EditHostSmtp.Text);
IniFile.WriteString ('Smtp','PortSmtp', EditPortSmtp.Text);
IniFile.WriteString ('Pop3','HostPop3', EditHostPop.Text);
IniFile.WriteString ('Pop3','PortPop3', EditPortPop.Text);
IniFile.WriteString ('User','UserName', EditUserName.Text);
IniFile.WriteString ('User','UserAddress', EditFrom.Text);

IniFile.WriteString ('Mailbox','Login', EditUserId.Text);

if CheckBox3.Checked = True then
  begin
    IniFile.WriteString ('Mailbox','SavePassword', '1');
    IniFile.WriteString ('Mailbox','Password', EditPassword.Text);
  end
else
  begin
     IniFile.WriteString ('Mailbox','SavePassword', '0');
     IniFile.WriteString ('Mailbox','Password', '');
     getmsg := IniFile.ReadString ('Temp','Getmsg', getmsg);

     if getmsg='1' then IniFile.WriteString ('Mailbox','Password', EditPassword.Text);
   end;

//Save delete messages
if CheckBox5.Checked = True then
   IniFile.WriteString ('Mailbox','Delete Messages', '1')
 else
    IniFile.WriteString ('Mailbox','Delete Messages', '0');
end;

procedure TPreferences2.ApplyClick(Sender: TObject);
begin
IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');
   SavePreferences;
   IniFile.WriteString('Temp','TestCancel', '0');
   IniFile.Destroy;
   close;
end;

procedure TPreferences2.RadioButton1Click(Sender: TObject);
begin
IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');
IniFile.WriteString ('Message','PriorityMessage', '0');
IniFile.Destroy;
end;

procedure TPreferences2.RadioButton2Click(Sender: TObject);
begin
IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');
IniFile.WriteString ('Message','PriorityMessage', '1');
IniFile.Destroy;
end;

procedure TPreferences2.RadioButton3Click(Sender: TObject);
begin
IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');
IniFile.WriteString ('Message','PriorityMessage', '2');
IniFile.Destroy;
end;

procedure TPreferences2.RadioButton4Click(Sender: TObject);
begin
IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');
IniFile.WriteString ('Message','PriorityMessage', '3');
IniFile.Destroy;
end;

procedure TPreferences2.RadioButton5Click(Sender: TObject);
begin
IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');
IniFile.WriteString ('Message','PriorityMessage', '4');
IniFile.Destroy;
end;

procedure TPreferences2.CancelClick(Sender: TObject);
begin
IniFile := TRegIniFile.Create ('SOFTWARE\SimpleMail');
IniFile.WriteString ('Temp','TestCancel', '1');
IniFile.Destroy;
Close;
end;
end.
